package AeroCrs;

use 5.018002;
use strict;
use warnings;

require Exporter;

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use AeroCrs ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	
);

our $VERSION = '0.01';


# Preloaded methods go here.

use XML::API;
use XML::Simple;

use LWP::UserAgent;
use HTTP::Request::Common;

use AeroCrs::Response;
use AeroCrs::Response::Booking;

sub new
{
  my $class = shift;

  my $self = {
    _token    => shift,
    _password => shift,
  };

  use constant API_ENDPOINT => scalar 'https://connect.aerocrs.com/v3/';

  bless $self, $class;
  return $self;
}

sub _post
{
  my $self = shift;
  my $xml = shift;

  my $user_agent = LWP::UserAgent->new(agent => 'perl post');

  my $response = $user_agent->request(POST API_ENDPOINT,
    Content_Type => 'application/xml',
    Content => $xml);

  return $response;
}

sub _parse_response
{
  my $self = shift;
  my $response = shift;

  if ($response->is_success) {
    my $booking = XMLin($response->content, forcearray => ['passenger', 'flight', 'remark']);
    return AeroCrs::Response::Booking->new($booking);
  }
  else {
    return "Error: ${response->status_line}"
  }
}

sub get_booking
{
  my $self = shift;
  my $prn = shift;
  my $lastname = shift;

  my $xml = XML::API->new();

  $xml->aerocrsapi_open();
  $xml->connector_open();
  $xml->id($self->{_token});
  $xml->password($self->{_password});
  $xml->connector_close();
  $xml->request('getBooking');
  $xml->params_open();
  $xml->bookingconfirmation($prn);
  $xml->passengerlastname($lastname);
  $xml->params_close();
  $xml->aerocrsapi_close();

  return $self->_parse_response($self->_post($xml->_as_string));
}


1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

AeroCrs - Perl extension for blah blah blah

=head1 SYNOPSIS

  use AeroCrs;
  blah blah blah

=head1 DESCRIPTION

Stub documentation for AeroCrs, created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head2 EXPORT

None by default.



=head1 SEE ALSO

Mention other useful documentation such as the documentation of
related modules or operating system documentation (such as man pages
in UNIX), or any relevant external documentation such as RFCs or
standards.

If you have a mailing list set up for your module, mention it here.

If you have a web site set up for your module, mention it here.

=head1 AUTHOR

Nathan, E<lt>nathan@E<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2016 by Nathan

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.18.2 or,
at your option, any later version of Perl 5 you may have available.


=cut
